<script>
import inputForm from './InputForm.vue';
import selectForm from './SelectForm.vue';
import longTextInput from './LongTextInput.vue';
import multipleTextChoice from './MultipleTextChoice.vue';
import inputDate from './InputDate.vue';

export default {
    props: {
        'itemInformations': Object,
        'formItemValue': {}
    },
    emits: ['update:formItemValue'],
    components: {
        inputForm,
        selectForm,
        longTextInput,
        multipleTextChoice,
        inputDate
    }
}
</script>

<!-- THIS COMPONENT IS USED ONLY IN THE CREATION / CORRECTION FORM OF AN OBJECT -->

<template>

    <div v-if="itemInformations['type'] === 'textType'" class="form-group">
        <label> {{ itemInformations["label"] }} </label>
        <inputForm :inputID="itemInformations['id']" :inputName="itemInformations['name']"
            :inputValue="formItemValue"
            @update:inputValue="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
    </div>

    <div v-else-if="itemInformations['type'] === 'textChoiceType'" class="form-group">
        <label> {{ itemInformations["label"] }} </label>
        <selectForm :selectID="itemInformations['id']" :selectName="itemInformations['name']"
            :options="itemInformations['options']"
            @update:selectedOption="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
    </div>

    <div v-else-if="itemInformations['type'] === 'longTextType'" class="form-group">
        <label> {{ itemInformations["label"] }} </label>
        <longTextInput :longInputID="itemInformations['id']" :longInputName="itemInformations['name']"
            :longInputValue="formItemValue"
            @update:longInputValue="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
    </div>

    <!-- <div v-else-if="itemInformations['type'] === 'booleanType'" class="form-group">
        <label> {{ itemInformations["label"] }} </label>
        <selectForm :selectID="itemInformations['id']" :selectName="itemInformations['name']"
            :options="[{ optionValue: null, optionName: 'Non renseigné', selected: true }, { optionValue: 'oui', optionName: 'Oui', selected: false }, { optionValue: 'non', optionName: 'Non', selected: false }]"
            @update:selectedOption="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
    </div> -->

    <div v-else-if="itemInformations['type'] === 'multipleTextChoiceType'" class="form-group">
        <label> {{ itemInformations["label"] }} </label>
        <multipleTextChoice :options="itemInformations['options']"
            @update:selectedValues="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
    </div>

    <div v-else-if="itemInformations['type'] === 'dateType'" class="form-group">
        <label> {{ itemInformations["label"] }} </label>
        <inputDate :inputDateID="itemInformations['id']"
            :inputDateName="itemInformations['name']"
            :inputDate="formItemValue"
            :isCreationDate="itemInformations['isCreationDate']"
            @update:inputDateValue="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
    </div>

</template>